#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/init.h>
#include <linux/timer.h>

struct timer_list mytimer;

static void myhandler(struct timer_list *)
{
  printk("myhandler() is called!\n");
}

static int __init timer_kernel_module_init(void)
{
  printk("timer_kernel_module_init()\n");

  timer_setup(&mytimer, myhandler, 0);
  mytimer.expires = jiffies + 2 * HZ; /* timeout == 2 seconds */

  printk("Timer started!\n");
  add_timer(&mytimer);

  return 0;
}

static void __exit timer_kernel_module_exit(void)
{
  del_timer(&mytimer);
  printk("timer_kernel_module_exit()\n");
}

module_init(timer_kernel_module_init);
module_exit(timer_kernel_module_exit);

MODULE_LICENSE("GPL");
MODULE_AUTHOR("Hiroyuki Chishiro");
MODULE_DESCRIPTION("Timer Kernel Module");
